funccount(8)

NAME
funccount - count kernel function calls matching specified wildcards. Uses Linux ftrace.

SYNOPSIS
funccount [-hT] [-i secs] [-d secs] [-t top] funcstring

DESCRIPTION
This tool is a quick way to determine which kernel functions are being called, and at what rate. It uses ftrace function profiling capabilities.

WARNING: This uses dynamic tracing of (what can be many) kernel functions, and could cause kernel panics or freezes. Test, and know what you are doing, before use.

Since this uses ftrace, only the root user can use this tool.

REQUIREMENTS
CONFIG_FUNCTION_PROFILER, which you may already have enabled and available on recent kernels, and awk.

OPTIONS
-d seconds Total duration of the trace.

-h  Print usage message.

-i seconds
    Print an interval summary every so many seconds.

-t top
    Print top number of entries only.

-T  Include timestamp on each summary.

funcstring
    A function name to trace, which may include file glob style wildcards ("*") at the beginning or ending of a string only. Eg, "vfs*" means match "vfs" followed by anything.

EXAMPLES

Count every kernel function beginning with "bio_", until Ctrl-C is hit:
    # funccount 'bio_*'

Count every "tcp_*" kernel function, and print a summary every one second, five in total:
    # funccount -i 1 -d 5 'tcp_*'

Count every "ext4*" kernel function, and print the top 20 when Ctrl-C is hit:
    # funccount -t 20 'ext4*'

FIELDS

FUNC
    Kernel function name.

COUNT
    Number of times this function was called during the tracing interval.

OVERHEAD
This uses the ftrace profiling framework, which does in-kernel counts, lowering the overhead (compared to tracing each event).

SOURCE
This is from the perf-tools collection:

    https://github.com/brendangregg/perf-tools

Also look under the examples directory for a text file containing example usage, output, and commentary for this tool.

OS
Linux

STABILITY
Unstable - in development.

AUTHOR
Brendan Gregg

SEE ALSO
functrace(8)